//----------------------------------------------------------------------//
// HTMLeLXgϊNX											//
//																		//
//----------------------------------------------------------------------//
#ifndef htmconvH
#define htmconvH

//---------------------------------------------------------------------------
#define DEF_LINE_WIDTH		80
#define DEF_BLANK_LN_LIMIT	3				//As

//---------------------------------------------------------------------------
#define NO_CRSPC_PTN	"^(#{1,6}|\\s*[\\*\\+\\-]|\\s*\\d+\\.)\\s.+|^```"

//---------------------------------------------------------------------------
class HtmConv
{
private:
	UnicodeString TxtLineBuf;
	bool Skip;
	bool fPRE, fXMP;
	int  BQ_level;

	UnicodeString rel_to_abs(UnicodeString fnam, UnicodeString rnam);

	UnicodeString int_to_alpha(int n);
	UnicodeString int_to_roman(int n);
	void del_tag_block(TStringList *lst, const _TCHAR *start_wd, const _TCHAR *end_wd);

	UnicodeString ToAbsUrl(UnicodeString url);
	UnicodeString GetTag(UnicodeString s);
	void FlushText(UnicodeString s = EmptyStr);
	void AddHR();

	bool is_rel_url(UnicodeString s)
	{
		return (!s.IsEmpty() && !TRegEx::IsMatch(s, "^(https?|mailto|file):|^//"));
	}

	void DecLevel(int &n)
	{
		n = std::max(n - 1, 0);
	}

public:
	HtmConv();
	~HtmConv();

	UnicodeString FileName;		//t@C
	UnicodeString UrlStr;		//URL
	UnicodeString TopLevel;		//gbvx
	UnicodeString Scheme;		//XL[
	UnicodeString BaseUrl;

	TStringList *HtmBuf;		//HTML̓obt@
	TStringList *TxtBuf;		//eLXgo̓obt@

	int  CodePage;				//o̓R[hy[W

	bool ToMarkdown;			//Markdown ɕϊ

	int  LineWidth;				//
	UnicodeString HeaderStr;	//o(;؂)
	UnicodeString UlMarkStr;	//UL}[N
	UnicodeString InsHrClass;	//wNXDIV̑OɌr}

	bool InsHdrInf;				//wb_}
	bool InsHrSection;			//<section>̑OɌr}
	bool InsHrArticle;			//<article>̑OɌr}
	bool InsHrNav;				//<nav>̑OɌr}

	UnicodeString DelBlkCls;	//폜 class Xg
	UnicodeString DelBlkId;		//폜 id Xg

	UnicodeString Title;
	UnicodeString Description;
	UnicodeString Keywords;

	void DelAtrBlock(TStringList *lst, UnicodeString anam, UnicodeString aval);
	UnicodeString GetTagAtr(UnicodeString s, UnicodeString t, const _TCHAR *a);
	UnicodeString RefEntity(UnicodeString s);
	void Convert();
};
//---------------------------------------------------------------------------
#endif
